{
  config,
  marleylib,
  lib,
  ...
}: let
  cfg = config.marleycfg.profiles;

  inherit (marleylib.module) enabled;
in {
  marleyos = lib.mkMerge [
    # Universal - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    {
      programs = {
        agenix = enabled;
        bat = enabled;
        curl = enabled;
        eza = enabled;
        fish = enabled;
        nh = enabled;
      };
    }
    #
    #
    # Graphical Desktop - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    (lib.optionalAttrs cfg.desktop {
      shell.niri = enabled;

      programs = {
        cheat = enabled;
        figlet = enabled;
        fzf = enabled;
        nemo = enabled;
      };

      services = {
        udiskie = enabled;
      };
    })
    #
    #
    # Server - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    (lib.optionalAttrs cfg.server {})
  ];
}
